#!/bin/sh
# chemin.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : chemin.tcl
#  Author  : Andr Connes <andre.connes@toulouse.iufm.fr>
#  Modifier:
#  Date    : 19/05/2004
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version    $Id: chemin.tcl,v 1.10 2004/08/19 14:14:29 abuledu_andre Exp $
#  @author     Andr Connes
#  @modifier
#  @project    Le terrier
#  @copyright  Andr Connes
#
#***********************************************************************
global sysFont glob

source chemin.conf
source msg.tcl
source fonts.tcl

#set basedir [file dir $argv0]
#cd $basedir

#if { [catch {package require Iwidgets}] == 1} {
#  tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets"
#}

#wm resizable . 0 0
. configure -background blue
wm geometry . [expr int($glob(width)*2/3)]x[expr int($glob(height)*2/3)]+0+0
wm title . "[mc {title_m}]"

# gestion de l'espace de l'utilisateur
  catch { file mkdir [file join $glob(home_chemin)]}
  catch { file mkdir [file join $glob(home_reglages)] }
  catch { file copy  [file join reglages lang.conf] [file join $glob(home_reglages)] }
  if {![file exists [file join  $glob(home_reglages) dir_exos.conf)]]} {
	set f [open [file join $glob(home_reglages) dir_exos.conf] "w"]
	puts $f "Commun"
	close $f
  }
  catch { file mkdir [file join $glob(home_msgs)] }
  # astuce suivante : ajoute automatiquement toute nouvelle langue chez l'utilisateur
  foreach f [glob [file join msgs *.msg]] {
	catch { file copy [file join $f] [file join $glob(home_msgs)]}
  }
  if {![file exists [file join  $glob(trace_dir)]]} {
	file mkdir [file join $glob(trace_dir)]
  }
  catch { file mkdir [file join $glob(home_chemin) grilles] }

proc forcer_nom {} {
  global glob
  set w [toplevel .wnom -borderwidth 10]
  wm geometry $w +200+300
  message $w.message -text [mc {Ton_nom}]
  entry $w.entry -textvariable glob(win_nom)
  button $w.ok -text Ok -command { set glob(ok) 1 }
  pack $w.message $w.entry $w.ok -side top -fill x

  bind .wnom <Return> { set glob(ok) 1 }

  focus $w.entry
  grab $w
  tkwait variable glob(ok)
  grab release $w
  destroy $w
  if { $glob(ok) } {
    if { [string length $glob(win_nom)] == 0 } {
      set glob(win_nom) "eleve"
    }
    set glob(trace_user) "$glob(trace_dir)/$glob(win_nom)"
  }
}

################################################
# les rpertoires des exercices peuvent tre : #
# - textes                                     #
# - images                                     #
# - sons                                       #
# - vidos                                     #
# - etc.                                       #
# donc 2 procdures  adapter au cas par cas ! #
################################################
proc init_dir_exos {} {
  global glob
  catch {set f [open [file join $glob(home_reglages) dir_exos.conf] "r"]}
  set glob(dir_exos) [gets $f]
  close $f
}

# changer le rpertoire de travail
proc change_dir_exos {} {
  global glob dir_exos
  catch {set f [open [file join $glob(home_reglages) dir_exos.conf] "w"]}
  puts $f $dir_exos
  close $f

# main_loop
}

proc setlang {lang} {
  global env glob
  set env(LANG) $lang
  catch {set f [open [file join $glob(home_reglages) lang.conf] "w"]}
  puts $f [file rootname [file tail $lang]]
  close $f

  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  main_loop
}

proc lanceappli {appli niveau} {
	global glob
	set appli [file join $appli]
	exec $glob(wish) $appli $niveau &
}

proc my_delfile { } {
  global glob
  set tchemin {
	{{Tous les fichiers} *}
  }
  set fname [tk_getOpenFile -title [mc Slection] \
	-initialdir [file join $glob(home_chemin) grilles] \
	-filetypes $tchemin]
  file delete $fname
}

###########################################################################################""

proc main_loop {} {
  global c sysFont glob

  #########################
  #      Barre de menus   #
  #########################

  # Creation du menu utilise comme barre de menu
  #---------------------------------------------
  catch {destroy .menu}
  catch {destroy .frame}

  menu .menu -tearoff 0

  # Creation du menu Fichier
  menu .menu.fichier -tearoff 0
  .menu add cascade -label [mc {Fichier}] -menu .menu.fichier
  .menu.fichier add command -label [mc {Editer Case}] -command "lanceappli editeur_case.tcl 0"
  .menu.fichier add command -label [mc {Supprimer Case}] -command my_delfile
  .menu.fichier add separator
  .menu.fichier add command -label [mc {Bilans}] -command "lanceappli bilan.tcl 0"
  .menu.fichier add separator
  .menu.fichier add command -label [mc {Quitter}] -command exit

  # Creation du menu Action
  menu .menu.action -tearoff 0
  .menu add cascade -label [mc {Activits}] -menu .menu.action
  .menu.action add cascade -label [mc {Cases}] -menu .menu.action.cases
  menu .menu.action.cases -tearoff 0
  	.menu.action.cases add command -label [mc Dcodage] \
		-command "lanceappli chemin_case_decode.tcl 0"
	.menu.action.cases add command -label [mc Codage_immediat]  \
		-command "lanceappli chemin_case_code_immediat.tcl 0"
	.menu.action.cases add command -label [mc Codage_differe]  \
		-command "lanceappli chemin_case_code_differe.tcl 0"
	.menu.action.cases add command -label [mc Cache]  \
		-command "lanceappli chemin_case_cache.tcl 0"
	.menu.action.cases add separator
	.menu.action.cases add command -label [mc D]  \
		-command "lanceappli chemin_case_un_de.tcl 0"
	.menu.action.cases add command -label [mc DeuxDs]  \
		-command "lanceappli chemin_case_deux_des.tcl 0"
	.menu.action.cases add command -label [mc Chiffre]  \
		-command "lanceappli chemin_case_chiffre.tcl 0"

  .menu.action add cascade -label [mc {Noeuds}] -menu .menu.action.noeud
  menu .menu.action.noeud -tearoff 0
  	.menu.action.noeud add command -label [mc Dcodage] \
		-command "lanceappli chemin_noeud_decode.tcl 0"
	.menu.action.noeud add command -label [mc Codage_immediat]  \
		-command "lanceappli chemin_noeud_code_immediat.tcl 0"
	.menu.action.noeud add command -label [mc Codage_differe]  \
		-command "lanceappli chemin_noeud_code_differe.tcl 0"
	.menu.action.noeud add command -label [mc Cache]  \
		-command "lanceappli chemin_noeud_cache.tcl 0"
	.menu.action.noeud add separator
	.menu.action.noeud add command -label [mc D]  \
		-command "lanceappli chemin_noeud_un_de.tcl 0"
	.menu.action.noeud add command -label [mc DeuxDs]  \
		-command "lanceappli chemin_noeud_deux_des.tcl 0"
	.menu.action.noeud add command -label [mc Chiffre]  \
		-command "lanceappli chemin_noeud_chiffre.tcl 0"


  .menu.action add cascade -label [mc {Route}] -menu .menu.action.route
  menu .menu.action.route -tearoff 0
  	.menu.action.route add command -label [mc Dcodage] \
		-command "lanceappli chemin_route_decode.tcl 0"
	.menu.action.route add command -label [mc Codage_immediat]  \
		-command "lanceappli chemin_route_code_immediat.tcl 0"
	.menu.action.route add separator
	.menu.action.route add command -label [mc D]  \
		-command "lanceappli chemin_route_un_de.tcl 0"
	.menu.action.route add command -label [mc DeuxDs]  \
		-command "lanceappli chemin_route_deux_des.tcl 0"
	.menu.action.route add command -label [mc Chiffre]  \
		-command "lanceappli chemin_route_chiffre.tcl 0"


  # Creation du menu Options
  menu .menu.options -tearoff 0
  .menu add cascade -label [mc {Options}] -menu .menu.options

  menu .menu.options.lang -tearoff 0 
  .menu.options add cascade -label "[mc {Langue}]" -menu .menu.options.lang

  foreach i [glob [file join  $glob(home_msgs) *.msg]] {
    set langue [string map {.msg "" } [file tail $i]]
    .menu.options.lang add radio -label $langue -variable langue -command "setlang $langue"
  }

  menu .menu.options.wdir -tearoff 0 
  .menu.options add cascade -label [mc {Rpertoire de travail}] -menu .menu.options.wdir
  .menu.options.wdir add radio -label [mc {Commun}] -variable dir_exos -value Commun -command "change_dir_exos"
  .menu.options.wdir add radio -label [mc {Individuel}] -variable dir_exos -value Individuel -command "change_dir_exos"

  # Creation du menu Aide
  menu .menu.aide -tearoff 0
  .menu add cascade -label [mc {Aide}] -menu .menu.aide
  .menu.aide add command -label [mc {Aide}] -command "exec $glob(progaide) aide.html &"
  .menu.aide add command -label [mc { propos ...}] -command "source apropos.tcl"

  . configure -menu .menu

  # creation du frame
  ###################
  . configure -background blue
  frame .frame -background blue -height $glob(height) -width $glob(width) 
  pack .frame -side top -fill both -expand yes

  # creation du canvas
  ####################

  set c .frame.c
  canvas $c -width $glob(width) -height $glob(height) -bg blue -highlightbackground blue
  pack $c -expand true

  set myimage [image create photo -file sysdata/background.gif]
  label $c.imagedisplayer -image $myimage -background blue
  grid $c.imagedisplayer -column 2 -row 0 -sticky e

  label $c.nimages -bg blue
  grid $c.nimages -column 1 -row 2

} ;# fin de main_loop

############
# Bindings #
############

bind . <Control-q> {exit}

########################################################################
#                           programme principal                        #
########################################################################

if { $glob(platform) == "windows" } {
  forcer_nom ;# forcer la lecture de glob(trace_user)
  # sauver trace_user
  catch {set f [open [file join $glob(home_chemin) reglages trace_user] "w"]}
  puts $f $glob(trace_user)
  close $f
}

main_loop

